require Installer;

package PKCS11Installer;
our @ISA = qw(Installer);

my $pkcs11lib = "libetpkcs11.so";
my $etokendlllib = "libetokendll.so";

$libdir = "/usr/local/lib";                     # directory where IFD Handler should be located

#functions
#constructor
sub new 
{
    my $newObj = {};
    bless $newObj;
    return $newObj;
}

sub install
{
     Installer::checkInstallations ();
     manageInstallFiles();
     system("/sbin/ldconfig");
     Installer::chkconfigSub ( "etsrvd","add", 30 );
     Installer::service ("etsrvd","start");
}

sub uninstall
{
     Installer::chkconfigSub ( "etsrvd","del", 30 );
     Installer::service ("etsrvd","stop");
     manageInstallFiles();
}

sub run
{
    Installer::prerequisites ();
    my $action = $ARGV[0] if ($#ARGV >= 0);
    if ($action eq "install") 
    {
	Installer::setAction ("install");
	install (); 
    }
    elsif ($action eq "uninstall") 
    {
	Installer::setAction ("uninstall");
	uninstall ();
    }  
    else
    {
      print "Aladdin PKCS #11 installation/uninstallation\n";
      print "Usage: $0 { install | uninstall }\n";
      exit 1;
   }
}

sub manageInstallFiles
{
    Installer::installDLL ( "libetokendll.so" );
    Installer::installDLL ( "libetpkcs11.so" );
    if ( Installer::isInstall () )
    {
       Installer::copyExecutable ( "etsrvd","/usr/local/sbin/etsrvd" ) ;
       Installer::copyExecutable ( "etsrvd.startup.script", "/etc/init.d/etsrvd");
       Installer::copyExecutable ( "etckinit", "/usr/local/bin/etckinit" );
       Installer::copyExecutable ( "etckdump", "/usr/local/bin/etckdump");
    }
    else#uninstall
    {
        `rm -f /usr/local/sbin/etsrvd` or die "$!\n";
        `rm -f /usr/local/bin/etckinit` or die "$!\n";
        `rm -f /usr/local/bin/etckdump` or die "$!\n";
    }
}



